package com.sqx.common.exception;

import com.sqx.common.utils.Result;
import org.apache.shiro.authz.AuthorizationException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.dao.DuplicateKeyException;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.HttpRequestMethodNotSupportedException;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.RestControllerAdvice;
import org.springframework.web.context.request.ServletWebRequest;
import org.springframework.web.context.request.WebRequest;
import org.springframework.web.servlet.NoHandlerFoundException;

/**
 * 异常处理器
 *
 * @author GYJ
 */
@RestControllerAdvice
public class SqxExceptionHandler {
    private final Logger logger = LoggerFactory.getLogger(getClass());

    /**
     * 处理自定义异常
     */
    @ExceptionHandler(SqxException.class)
    public Result handleException(SqxException e) {
        Result r = new Result();
        r.put("code", e.getCode());
        r.put("msg", e.getMessage());

        return r;
    }

    @ExceptionHandler(NoHandlerFoundException.class)
    public Result handlerNoFoundException(Exception e, WebRequest webRequest) {
        logErrorInfo(webRequest);
        logger.error(e.getMessage(), e);
        return Result.error(404, "路径不存在，请检查路径是否正确");
    }

    @ExceptionHandler(DuplicateKeyException.class)
    public Result handleDuplicateKeyException(DuplicateKeyException e, WebRequest webRequest) {
        logErrorInfo(webRequest);
        logger.error(e.getMessage(), e);
        return Result.error("数据库中已存在该记录");
    }

    @ExceptionHandler(AuthorizationException.class)
    public Result handleAuthorizationException(AuthorizationException e, WebRequest webRequest) {
        logErrorInfo(webRequest);
        logger.error(e.getMessage(), e);
        return Result.error("没有权限，请联系管理员授权");
    }

    @ExceptionHandler(HttpRequestMethodNotSupportedException.class)
    public Result httpRequestMethodNotSupportedException(Exception e, WebRequest webRequest) {
        logErrorInfo(webRequest);
        logger.error(e.getMessage());
        return Result.error();
    }

    @ExceptionHandler(Exception.class)
    public Result handleException(Exception e, WebRequest webRequest) {
        logErrorInfo(webRequest);
        logger.error(e.getMessage(), e);
        return Result.error();
    }

    @ExceptionHandler(CzgException.class)
    public ResponseEntity<Void> handleCzgException() {
        // 响应状态码为 444 表示无法处理的异常
        return new ResponseEntity<>(HttpStatus.TOO_MANY_REQUESTS);
    }

    private void logErrorInfo(WebRequest webRequest) {
        if (webRequest instanceof ServletWebRequest) {
            ServletWebRequest servletWebRequest = (ServletWebRequest) webRequest;
            String requestUrl = servletWebRequest.getRequest().getRequestURI();
            logger.error("请求路径：{}，发生异常", requestUrl);
        }
    }
}
